/* ------------------------------------- */
/* 4.4.4 V쵲C                */
/* sW`I          addHead(), insert() */
/* R`I   removeHead(), removeTail() */
/* ------------------------------------- */

#include<stdio.h>
#include<stdlib.h>

typedef struct Node   //wqV쵲Có]OO
{
   int item;           //
   struct Node *Rnext; // Rnext VU@Ӹ`I
   struct Node *Lnext; // Lnext VW@Ӹ`I
}CDBnode;
typedef CDBnode *cdlink;//V`Iܼ

cdlink head = NULL;

cdlink addHead(int);   //sW`IĤ@Ӹ`Ie
cdlink insert(int);    //s`I[Ĥ@`IAL`Ie
cdlink removeHead();   //RĤ@Ӹ`I
cdlink removeTail();   //R̫@Ӹ`I
void display();        //LX`I
void displayNode(cdlink);

/* s`I[Ĥ@Ӹ`IeAܦ`I */
cdlink addHead(int value)
{
   cdlink newNode, ptr = NULL;
   newNode = (cdlink) malloc(sizeof(CDBnode)); //Ns`ItmO
   newNode->item = value;

   if(head != NULL)   //ͲĤ@Ӹ`I
   {
      head->Lnext->Rnext = newNode; //1 e@Ӹ`Ik쵲Vs`I
      newNode->Rnext = head;        //2 s`Ik쵲VĤ@Ӹ`I
      newNode->Lnext = head->Lnext; //3 s`I쵲Ve@Ӹ`I
      head->Lnext = newNode;        //4 Ĥ@Ӹ`I쵲Vs`I
      head = newNode;               //5 ܧs`IĤ@Ӹ`I
   }
   return head;
}

/* sW`IA[Ĥ@Ӹ`IAL`Ie */
cdlink insert(int value)
{
   cdlink ptr = head, newNode;
   newNode = (cdlink) malloc(sizeof(CDBnode)); //Ns`ItmO
   newNode->item = value;

   if(head == NULL)   //ͲĤ@Ӹ`I
   {
      newNode->Rnext = newNode; //1.s`Ik쵲RnextVCĤ@Ӹ`I
      newNode->Lnext = newNode; //2.Ns`I쵲LnextVs`I
      return newNode;
   }

   else if(ptr == NULL) //[JĤGӸ`IĤ@Ӹ`I
   {
      head->Lnext->Rnext = newNode; //e@Ӹ`Ik쵲Vs`I
      newNode->Rnext = head;        //s`Ik쵲VĤ@Ӹ`I
      newNode->Lnext = head->Lnext; //s`I쵲Ve@Ӹ`I
      head->Lnext = newNode;        //Ĥ@Ӹ`I쵲Vs`I
      head = newNode;
   }
   else
   {
       ptr->Rnext->Lnext = newNode; //ثe`Ik쵲RnextVUӸ`I쵲s`I
       newNode->Rnext = ptr->Rnext; //Ns`Ik쵲RnextVثe`Ik쵲VU@Ӹ`I
       newNode->Lnext = ptr;        //Ns`I쵲LnextVثe`I
       ptr->Rnext = newNode;        //ثe`Ik쵲Vs`I
   }
   return head;
}

/* RĤ@Ӹ`I */
cdlink removeHead()
{
   cdlink ptr = head;
   while(ptr->Rnext != head)   //XC
      ptr = ptr->Rnext;
   ptr->Rnext = head->Rnext;
   cdlink target = head;
   head = head->Rnext;
   head->Lnext = ptr;
   free(target);
   return head;
}

/* R̫@Ӹ`I */
cdlink removeTail()
{
   cdlink ptr = head;
   while(ptr->Rnext != head) //XC̫ܳ@Ӹ`IAptrV
      ptr = ptr->Rnext;
   ptr->Lnext->Rnext = head; //R`I쵲ҫ`Ik쵲VĤ@Ӹ`I
   head->Lnext = ptr->Lnext; //Ĥ@Ӹ`I쵲VR`Ie@Ӹ`I
   free(ptr);
   return head;
}

void display() //LX`Ie
{
   if(head == NULL) //Ĥ@Ӹ`I~|LXL`I
      printf("L!\n");
   else
      displayNode(head);  //Is禡showNode()o`Ie
}

/* ̾ګЫV`IӨo䤺e */
void displayNode(cdlink current)
{
   //XCLXRnextҫ`Ie
   while(current->Rnext != head)
   {
   	printf("[%3d]->", current->item);
	   current = current->Rnext;
	}
	printf("[%3d]\n", current->item); //̫@Ӹ`I
}

void main() //D{
{
   int number[] = {162, 454, 29, 353, 76, 114};
   //̰}CͦC
   printf("V쵲CF\n");
   for(int j = 0; j < 6; j ++)
   {
      head = insert(number[j]);
      display();
   }

   printf("sW`Ie\n");
   head = addHead(87);
   display();
   head = addHead(135);
   display();

   printf("Ĥ@Ӹ`IR...");
   head = removeHead();
   display();

   printf("̫@Ӹ`IR...");
   head = removeTail();
   display();

   free(head);
}
