/* --------------------------- */
/* 4.5.1 hPV쵲C  */
/* --------------------------- */

#include <stdio.h>
#include<stdlib.h>

/* wqe1Be2GAx = y, ^0, e1 > e2 ^1, _hNOe1 < e2, ^-1 */
#define MATCH(e1, e2) ((e1 == e2) ? 0 : ((e1 > e2) ? 1 : -1))

typedef struct Node     //wqh
{
   int coef;           //hDsY
   int exp;            //h
   struct Node *next;  // next VU@Ӹ`I
}Pnode;
typedef Pnode *plink;  //V`Iܼ

plink head = NULL;
plink createItem(plink, int, int); //lƦhAରC
plink addPoly(plink, plink);       //Ӧhۥ[
void display(plink);               //LXC

/* ͦCæbh[J@ӫDs */
plink createItem(plink last, int cf, int num)
{
   plink ptr, newNode;
   if(head == NULL)
   {
      newNode = (plink)malloc(sizeof(Pnode)); //tmO
      newNode->coef = cf;   //ͫY
      newNode->exp = num;   //o
      newNode->next = NULL; //lƫ
      last->next = newNode; //s`I[̫`I
      last = newNode;       //s`I̫`I
   }
   return last;
}

/* NରChۥ[ */
plink addPoly(plink item1, plink item2)
{
   plink ptr, item3;
   item3 = (plink)malloc(sizeof(Pnode)); //tmOAxsۥ[᪺h
   ptr = item3;

   item1 = item1->next; //VĤ@Ӧh}lB
   item2 = item2->next; //VĤGӦh}lB

   while(item1 && item2) //ӦhDŪΤUA
   {
      switch(MATCH(item1->exp, item2->exp))
      {
         //p@Gitem1 < item2ơAh[Jitem2Ds
         case -1:
            //N2ӦhH禡ରCèoYơB
            ptr = createItem(ptr, item2->coef, item2->exp);
	         item2 = item2->next; //VU@Ӹ`I
	         break;

         //pGGitem1 = item2ơAӦhYƬۥ[
         case 0:
            if((item1->coef + item2->coef) != 0)
	            ptr = createItem(ptr, item1->coef +
                     item2->coef, item1->exp);
	         item1 = item1->next;
            item2 = item2->next;
	         break;

         //pTGitem1 > item2ơAh[Jitem1Ds
         case 1:
            ptr = createItem(ptr, item1->coef, item1->exp);
	         item1 = item1->next;
	         break;
      }
   }

   //h[Jitem1LDs
   while(item1)
   {
      ptr = createItem(ptr, item1->coef, item1->exp);
	   item1 = item1->next;
   }

   //h[Jitem2LDs
   while(item2)
   {
      ptr = createItem(ptr, item2->coef, item2->exp);
	   item2 = item2->next;
   }
   return item3;
}

/* ̾ڦhӿXCe */
void display(plink poly)
{
   while(poly != NULL)
   {
   	printf("%2dX^%d", poly->coef, poly->exp);
	   poly = poly->next;
	   if(poly != NULL)
         printf(" + ");
	}
	printf("\n");
}

void main()
{
   plink item1, item2, item3, result;

   //Nitem1 h1 tmOêl
   item1 = (plink)malloc(sizeof(Pnode));
   result = createItem(item1, 3, 6);
   result = createItem(result, 8, 4);
   result = createItem(result, 6, 2);
   result = createItem(result, 7, 0);
   result = item1->next;
   printf("h<1> ");
   display(result);

   //N item2 h2 tmOêl
   item2 = (plink)malloc(sizeof(Pnode));
   result = createItem(item2, -4, 2);
   result = createItem(result, 7, 5);
   result = createItem(result, -1, 0);
   result = item2->next;
   printf("h<2> ");
   display(result);

   // pitem3(X) = item1(X) + item2(X)
   item3 = addPoly(item1, item2);
   result = item3->next;
   printf("h ۥ[ --> ");
   display(result);
}
