#include<stdio.h>
#include<stdlib.h>

#define Max 100   //|s񪺤

/*ŧistackO|Ƶc*/
typedef struct node
{
  char item[Max];			//s|
  int top;			      //O|
}stackNode;

stackNode stack;   //*ŧi@Ӱ|SsBlMA*/

void push(char);
void pop(char*);
void InfixtoPostfix(char*, char*);

/*oӨƷ|NѼƱJ|*/
void push(char value)
{
   if(stack.top < Max - 1)
      stack.item[++stack.top] = value;
}

/*oӨƷ|q|uX@ӤæsbѼƫw}*/
void pop(char *value)
{
   if (stack.top > -1)
      *value = stack.item[stack.top--];
}

/*oӨƷ|ˬdѼƬO_BlAOܡAǦ^1A_ܡAǦ^0*/
int isOpr(char op)
{
   switch (op)
   {
      case '+':
      case '-':
      case '*':
      case '/': return 1; //OBl
      default:  return 0; //OBl
   }
}

/*oӨƷ|ˬdѼƬO_B⤸AOܡAǦ^1A_ܡAǦ^0*/
int isOperand(char value)
{
   if (value >= 'a' && value <= 'z')
      return 1;
   else
      return 0;
}

/*oӨƷ|ھڰѼƫwBlǦ^u*/
int getPrior(char op)
{
    switch(op){
      case '(': return 0;
      case '+': return 1;
      case '-': return 1;
      case '*': return 2;
      case '/': return 2;
      default:  return -1;
    }
}

/*oӨƷ|NǪܪkഫǪܪk*/
void InfixtoPostfix(char *infix, char *postfix)
{
   int i = 0, j = 0;
   char token, item;

   while((token = infix[i++]) != '\0')
   {
	   if (isOperand(token))
		   postfix[j++] = token;
	   else if (token == '(')
		   push(token);
	   else if (token == ')')
	   {
	      while (stack.top > -1)
         {
		      pop(&item);
		      if (item == '(')
               break;
		      postfix[j++] = item;
		   }
      }
	   else if (isOpr(token))
      {
         while (stack.top > -1)
         {
            if (getPrior(token) > getPrior(stack.item[stack.top]))
               break;
            else
            {
               pop(&item);
			      postfix[j++] = item;
		     }
	      }
		   push(token);
	   }
   }
   while(stack.top > -1)
   {
		pop(&item);
		postfix[j++] = item;
   }
   postfix[j] = '\0';
}

/*D{*/
void main()
{
   char infix[Max] = "((a-(b+c))*d)/(e-f)";  //ŧiǦ
   char postfix[Max];                //sഫ᪺Ǧ
   InfixtoPostfix(infix, postfix);   //Isưഫ
   printf("Ǧ %s", infix);
   printf("\n ഫǦ --> %s", postfix);
}
