#include<stdio.h>
#include<stdlib.h>

typedef struct tree        //쵲CܤG
{
   int item;               //`I
   int balance;            //ūY
   struct tree *left;      //Vl
   struct tree *right;     //Vkl
}treeNode;
typedef treeNode *btree;   //ŧi𪺫

typedef enum{FALSE, TRUE} bool;

btree append(btree, int, bool *);
btree search(btree, int);
void display(btree, int);
void inorder(btree ptr);

/* HjjM`I */
btree search(btree ptr, int value)
{
   if(ptr != NULL)
   {
      if(value < ptr->item)
         ptr = search(ptr->left, value);
      else if(value > ptr->item)
         ptr = search(ptr->right, value);
   }
   return ptr;
}

/* J`IɨåH|ثӽվ㬰AVL */
btree append(btree ptr, int value, bool *ht)
{
   btree pivot, crucial;
   if(ptr == NULL)
   {
      //إ߷s`IO
      ptr = (btree)malloc(sizeof(treeNode));
      //lƤG𪺸MBk
      ptr->item = value;
      ptr->balance = 0;
      ptr->left = NULL;
      ptr->right = NULL;
      *ht = TRUE;
      return ptr;
   }

   //J < ثe`I
   if(value < ptr->item)
   {
      //jIsappend()禡J`I쥪l
      ptr->left = append(ptr->left, value, ht);
      if(*ht == TRUE)
      {
         //P_īYƤTتp 1, 0, -1
         switch(ptr->balance)
         {
            case -1: //kl
               ptr->balance = 0;
               *ht = FALSE;
               break;
            case 0:   //
               ptr->balance = 1;
               break;
            case 1:   //l
               crucial = ptr->left; //վ㥪l
               if(crucial->balance == 1)
               {
                  printf("iLLվ\n");
                  //Nثe`Ilվ㬰`Icrucialkl
                  ptr->left = crucial->right;
                  //NptrVվ`I
                  crucial->right = ptr;
                  ptr->balance = 0;
                  crucial->balance = 0;
                  ptr = crucial;
               }
               else
               {
                  printf("iLRվ\n");
                  //N`Icrucialkl𰵱
                  pivot = crucial->right;
                  //N`Ilରkl
                  crucial->right = pivot->left;
                  pivot->left = crucial;
                  ptr->left = pivot->right;
                  pivot->right = ptr;

                  if(pivot->balance == 1)
                     ptr->balance = -1;
                  else
                     ptr->balance = 0;

                  if(pivot->balance == -1)
                     crucial->balance = 1;
                  else
                     crucial->balance = 0;
                  pivot->balance = 0;
                  ptr = pivot;
               }
               *ht = FALSE;
               break;
         }
      }
   }

   if(value > ptr->item)
   {
      ptr->right = append(ptr->right, value, ht);
      if(*ht == TRUE)
      {
         switch(ptr->balance)
         {
            case 1:   //l
               ptr->balance = 0; 
               *ht = FALSE;
               break;
            case 0:  //
               ptr->balance = -1;
               break;
            case -1:  //l
               crucial = ptr->right;
               if(crucial->balance == -1)
               {
                  printf("iRRվ\n");
                  //վkl𪺥k`IAm󥪤l
                  ptr->right = crucial->left;
                  crucial->left = ptr;
                  ptr->balance = 0;
                  crucial->balance = 0;
                  ptr = crucial;
               }
               else
               {
                  printf("iRLվ\n");
                  pivot = crucial->left;
                  crucial->left = pivot->right;
                  pivot->right = crucial;
                  ptr->right = pivot->left;
                  pivot->left = ptr;

                  if(pivot->balance == -1)
                     ptr->balance = 1;
                  else
                     ptr->balance = 0;

                  if(pivot->balance == 1)
                     crucial->balance = -1;
                  else
                     crucial->balance = 0;
                  pivot->balance = 0;
                  ptr = pivot;
               }
               *ht = FALSE;
               break;
         }
      }
   }
   return ptr;
}

/* LX𪺤e */
void display(btree ptr, int level)
{
   int j;
   if(ptr != NULL)
   {
      display(ptr->right, level + 1);
      printf("\n");
      for(j = 0; j < level; j++)
         printf(" ");
      printf("[%d]", ptr->item);
      display(ptr->left, level + 1);
   }
}

/*  ǨXG  */
void inorder(btree ptr)
{
   if(ptr != NULL)
   {
      inorder(ptr->left);           //1.Xl
      printf("[%d]->", ptr->item);  //2.AX
      inorder(ptr->right);          //3.̫ᨫXkl
   }
}

void main() //D{
{
   int value, select;
   bool hti;
   btree root = (btree)malloc(sizeof(treeNode));
   root = NULL;
   while(1)
   {
      printf("1.sW 2.X 3.\n");
      printf("JﶵG");
      scanf("%d", &select);
      
      switch(select)
      {
         case 1:
            printf("Js -> ");
            scanf("%d", &value);
            if(search(root, value) == NULL)
               root = append(root, value, &hti);
            else
               printf("Jƪ!!");
            break;
         case 2:
            if(root == NULL)
            {
               printf("Ū...");
               continue;
            }
            printf(" ->\n");
            display(root, 1);
            printf("\n\n");
            printf("HǨX ->");
            inorder(root);
            printf("\n");
            break;
         case 3:
            exit(1);
         default:
            printf("ﶵT\n");
      }
   }
}
