/* ------------------------ */
/* ILI̵u| */
/* ϥ Dijkstra tk     */
/* ------------------------ */

#include<stdio.h>
#include<stdlib.h>

#define MAXLEN  10000  //Z̤j

int wgMatrix[9][9];    //xstvȪ۾Fx}
int dist[9];           //sY@ILI̵uZ

/* إߥ[vϧ */
void graphCreate(int *edges, int len)
{
   int start, halt, j;   //u_Istart, I halt

   //Ū`uó]_IBIAAsJϧ
   for(j = 0; j <= len; j++)
   {
      start = edges[j * 3];
      halt  = edges[j * 3 + 1];
      //printf("start = %d, halt = %d\n", start, halt); //d֦VϪu
      wgMatrix[start][halt] = edges[j * 3 + 2];
   }
}

/*  oYIUI̵uZ  */
void Dijkstra(int vertex, int len)
{
   int choice[9];           //sI
   int small, svex, j, k;   //small̤p, svext̯xI

   //]ȬsӲM}CñN|l
   for(j = 1; j <= len; j++)
   {
      choice[j] = 0;
      dist[j] = wgMatrix[vertex][j];
   }
   choice[vertex] = 1;           //xsQL}lI
   dist[vertex] = 0;             //]}lIZ

   printf("I ");
   for(k = 1; k <= len; k++)    //kȿXI1~8
      printf("%-7d", k);
   printf("\n");
   for(k = 1; k <= len; k++ )
      printf("%6d ", dist[k]);  //LXZ
   printf("\n");

   //ŪI
   for(j = 1; j <= len - 1; j++ )
   {
      small = MAXLEN;             //]O̪Z
      for(k = 1; k <= len; k++ )  //X̵uZ
      {
         //q}CX̪ZI
         if(small > dist[k] && choice[k] == 0)
         {
            svex = k;          //o̵uI
            small = dist[k];   //O̵uZ
         }
      }

      choice[svex] = 1;       //ܤwQL

      //p}lIUI̵uZ}C
      for(k = 1; k <= len; k++ )
      {
         if(choice[k] == 0 &&     //u_?
               dist[svex] + wgMatrix[svex][k] < dist[k])
            //]uZ
            dist[k] = dist[svex] + wgMatrix[svex][k];
         printf("%6d ", dist[k]);
      }
      printf("\n");
   }
}

void main()
{
   int edges[11][3] = {{5, 4, 1350},
                       {5, 6,  300},
                       {6, 4,  900},
                       {6, 8, 1300},
                       {6, 7,  850},
                       {4, 3, 1100},
                       {7, 8,  930},
                       {3, 2,  800},
                       {3, 1, 1000},
                       {2, 1,  300},
                       {8, 1, 1650} };
   int j, k;

   for(j = 1; j <= 8; j++ )
      for(k = 1; k <= 8; k++ )
         wgMatrix[j][k] = MAXLEN;   //]w}C̪Z
   graphCreate(*edges, 9);          //إߦvȪ۾Fx}

   printf(" -------------------tvȪ۾Fx}-------------------\n");
   for(j = 1; j <= 8; j++)
   {
      for(k = 1; k <= 8; k++)
         printf(" %5d ", wgMatrix[j][k]);
      printf("\n");
   }
   printf("\nqI[5]UI̵uZpL{:\n");
   Dijkstra(5, 8); //Is禡X̵uZ
}
