/* ---------------------------------------------- */
/* 4.4.3 R`I                                 */
/* <1> RCĤ@Ӹ`I         removeFirst() */
/* <2> RC̫`I           removeLast()  */
/* <3> RYӫw`Ie@Ӹ`I removeItem()  */
/* ---------------------------------------------- */

#include<stdio.h>
#include<stdlib.h>

typedef struct Node   //wqV쵲Có]OO
{
   int item;           //
   struct Node *Rnext; // Rnext VU@Ӹ`I
   struct Node *Lnext; // Lnext VW@Ӹ`I
}Dbnode;
typedef Dbnode *dlink;//V`Iܼ

dlink head = NULL;

dlink createItem(int*, int); //͸`I
dlink removeFirst();         //Ĥ@Ӹ`I
dlink removeLast();          //̫@Ӹ`I
dlink removeItem(int);       //o`IARe@Ӹ`I
void display();              //LX`I
void displayNode(dlink);

/* ̾ڶǤJ}CtmOêlƦC */
dlink createItem(int *ary, int len)
{
	dlink ptr, newNode, previous;

	head = (dlink) malloc(sizeof(Dbnode)); //Ns`ItmO
	if(! head)                           //ˬdOtm
      return NULL;

   head->item = ary[0];   //N}CĤ@Ӥ]Ĥ@Ӹ`I
   head->Lnext = NULL;    //VW@Ӹ`ILnextVNULL
   head->Rnext = NULL;    //VU@Ӹ`IRnextVNULL

   previous = head;

	for(int j = 1; j < len; j++)  //Ū}CƬL`I
	{
      newNode = (dlink) malloc(sizeof(Dbnode)); //Ns`ItmO
      if(!newNode)             //ˬdOtm
         return NULL;

      newNode->item = ary[j];
      newNode->Rnext = NULL;
      newNode->Lnext = previous; //s`IRnextVe`I
      previous->Rnext = newNode; //e`ILnextVs`I
      previous = newNode;
      //printf("Node = %3d ", newNode->item);
   }
   return head;
}

/* Ĥ@Ӹ`IAܧ󭺸`Ik쵲RnextҫU@Ӹ`IĤ@Ӹ`I */
dlink removeFirst()
{
   dlink ptr = head;
   head = head->Rnext; //Ĥ@Ӹ`Ik쵲RnextҫU@Ӹ`Iܧ󬰭`I
   head->Lnext = NULL; //NR`I쵲]NULL
   free(ptr);          //Ĥ@Ӹ`IҦΪO
   return head;
}

/* ̫@Ӹ`I */
dlink removeLast()
{
   dlink ptr = head;
   while(ptr->Rnext != NULL)
      ptr = ptr->Rnext; //ثe`Ik쵲RnextҫU@Ӹ`Iܧ󬰥ثe`I
   //ثe`I쵲LnextҫVe`Ik쵲RnextܧNULL
   ptr->Lnext->Rnext = NULL;
   free(ptr);          //Ĥ@Ӹ`IҦΪO
   return head;
}

/* o`IAe@Ӹ`I */
dlink removeItem(int value)
{
   dlink ptr = head;

   while(ptr->item != value)//XCw`I
      ptr = ptr->Rnext;

   dlink tmp = ptr->Lnext;  //ثe`I쵲Lnexte`IR`Itmp
   if(tmp == head)          //R`IOĤ@Ӹ`I
      head = removeFirst();
   else
   {
      ptr->Lnext = tmp->Lnext;//ثe`I쵲ܧ󬰱R`IeӸ`I
      tmp->Lnext->Rnext = ptr;//R`Ie`Ik쵲Vثe`I
   }
   free(tmp);
   return head;
}

void display() //LX`Ie
{
   if(head == NULL) //Ĥ@Ӹ`I~|LXL`I
      printf("L!\n");
   else
      displayNode(head);  //Is禡showNode()o`Ie
}

/* ̾ګЫV`IӨo䤺e */
void displayNode(dlink current)
{
   //XCLXRnextҫ`Ie
   while(current->Rnext != NULL)
   {
   	printf("[%d]->", current->item);
	   current = current->Rnext;
	}
	printf("[%d]->NULL \n", current->item); //̫@Ӹ`I
}

void main() //D{
{
   int number[] = {568, 162, 29, 353, 76, 114};

   //̰}CͦC
   printf("ӦC ->");
   head = createItem(number, 6);
   display();

   head = removeFirst();
   printf("Ĥ@Ӹ`IG\n");
   display();

   head = removeLast();
   printf("̫@Ӹ`I -->\n");
   display();

   int data;
   printf("J`I->");
   scanf("%d", &data);
   head = removeItem(data);
   printf("`I %d e@Ӹ`IwR\n", data);
   display();
}
