/* ----------------------------- */
/* 4.5.2 }x}P쵲C  */
/* ----------------------------- */

#include <stdio.h>
#include<stdlib.h>

typedef struct Node     //wqC
{
   int row;             //x}C
   int colm;            //x}
   int item;            //xs
   struct Node *right;  // right VP@C`I
   struct Node *down;   // down VP@`I
}Cnode;
typedef Cnode *clink;   //V`Iܼ

clink head = NULL;

clink createItem(int, int);
clink insert(clink, int, int, int);
void display();

/* ͵}x}Ĥ@Ӹ`I */
clink createItem(int row, int colm)
{
   int len;
   //o}CסAHCB檺̤j
   if(row > colm)
      len = row;
   else
      len = colm;
   
   head = (clink)malloc(sizeof(Cnode) * len); //tmO
   if(! head)
      return NULL;
   //]w}CCB
   head[0].row = row;
   head[0].colm = colm;
   //lƫ, ñNЫVۤv
   for(int j = 0; j < len; j++)
   {
      head[j].right = &head[j];
      head[j].down = &head[j];
   }
   return head;
}

/* }}C}CJ */
clink insert(clink head, int row, int colm, int value)
{
   clink newNode, pos;
   newNode = (clink)malloc(sizeof(Cnode)); //tmOӲͷs`I
   if(!newNode)
      return NULL;
   
   //إ߹ڪ}x}
   newNode->row = row;   //C
   newNode->colm = colm; //
   newNode->item = value;//
   
   //ѫdownഫC
   pos = &head[colm];
   //XCӴJC
   while((pos->down != &head[colm]) && row > pos->down->row)
      pos = pos->down;        //VU@Ӹ`I
      
   newNode->down = pos->down; //s`IVU@Ӹ`I
   pos->down = newNode;       //e@Ӹ`Is`I
   
   //ѫrightഫCC
   pos = &head[row];
   //XCӴJ
   while(pos->right != &head[row] &&
         colm > pos->right->colm)
      pos = pos->right;

   newNode->right = pos->right; //s`IVU@Ӹ`I
   pos->right = newNode;       //e@Ӹ`Is`I
   return head;
}

/* X}x} */
void display()
{
   clink ptr, current;
   printf("  C        \n");
   printf("------------------\n");
   
   //downЧΦC
   for(int j = 0; j < head[0].colm; j++)
   {
      current = head[j].down;
      ptr = &head[j];
      while(current != ptr)
      {
         printf("[%3d][%3d] = [%3d]\n",
            current->row, current->colm, current->item);
         current = current->down;
      }
   }
}

void main()
{
   int sparse[4][5] = {  0, 4,  0, 0, 3,
                       -12, 3,  0, 9, 0,
                         0, 0, 11, 0, 2,
                         0, 0,  0, 6, 0 };
   int j, k;
   head = createItem(4, 5);
   for(j = 0; j < 4; j++)
   {
      for(k = 0; k < 5; k++)
      {
         if(sparse[j][k] != 0)
            head = insert(head, j, k, sparse[j][k]);
      }
   }
   display();
}
