/* ===================== */
/*    ǨXG     */
/*          E            */
/*         / \           */
/*        D   F          */
/*       /     \         */
/*      B       H        */
/*     / \     / \       */
/*    A   C   G   I      */
/* ===================== */

#include<stdio.h>
#include<stdlib.h>

typedef struct tree              //쵲CܤG
{
   char item;                    //`I
   struct tree *left;            //Vl
   struct tree *right;           //Vkl
}treeNode;
typedef treeNode *btree;       //ŧi𪺫

btree treeCreate(char*, int);
btree append(btree, char);
void inorder(btree);
void preorder(btree);
void postorder(btree);

/*  ͤG   */
btree treeCreate(char *ary, int len)
{
   btree root = NULL;

   for(int j = 0; j < len; j++)    /* ΰjإ߾𪬵c */
      root = append(root, ary[j]);
   return root;
}

/*  JG𪺸`I  */
btree append(btree root, char value)
{
   btree newNode, ptr, papa;

   //إ߷s`IO
   newNode = (btree)malloc(sizeof(treeNode));
   //lƤG𪺸MBk
   newNode->item = value;
   newNode->left = NULL;
   newNode->right = NULL;

   if (root == NULL)
   {
      return newNode;
   }
   else
   {
      ptr = root; //ptrШXC
      while (ptr != NULL )
      {
         papa = ptr;           //o`Ipapa
         //ثe`I > ǤJȴN]lA_hNOkl
         if (ptr->item > value )
            ptr = ptr->left;
         else
            ptr = ptr->right;
      }
      if (papa->item > value)   //_Bl쵲
         papa->left = newNode;
      else
         papa->right = newNode;
   }
   return root;
}

/*  ǨXG  */
void inorder(btree root)
{
   if(root != NULL)
   {
      inorder(root->left);           //1.Xl
      printf("[%c]->", root->item);  //2.AX
      inorder(root->right);          //3.̫ᨫXkl
   }
}

/*  eǨXG  */
void preorder(btree ptr)
{
   if(ptr != NULL)
   {
      printf("[%c]->", ptr->item);  //1.X
      preorder(ptr->left);          //2.AXl
      preorder(ptr->right);         //3.̫ᨫXkl
   }
}

/*  ǨXG  */
void postorder(btree root)
{
   if(root != NULL)
   {
      postorder(root->left);         //1.Xl
      postorder(root->right);        //2.MᨫXkl
      printf("[%c]->", root->item);  //3.̫O
   }
}

void main()
{
   btree root = NULL;             //
   char ary[9] = {'E', 'F', 'D', 'H', 'B', 'C', 'G', 'A', 'I'};
   root = treeCreate(ary, 9);

   printf("ǨX\n");
   inorder(root);

   printf("\neǨX \n");
   preorder(root);

   printf("\nǨX\n");
   postorder(root);
}
