/* ====================== */
/*  RGjM𪺸`I  */
/*           60           */
/*         /   \          */
/*       25    93         */
/*      / \   /           */
/*    18  34 79           */
/* ====================== */

#include<stdio.h>
#include<stdlib.h>

typedef struct tree        //쵲CܤG
{
   int item;               //`I
   struct tree *left;      //Vl
   struct tree *right;     //Vkl
}treeNode;
typedef treeNode *btree;   //ŧi𪺫

btree append(btree, int);
btree btreeFind(btree, int, int *);
btree btreeDelete(btree, int);

/*  JG𪺸`I  */
btree append(btree root, int value)
{
   btree newNode, ptr, papa;

   //إ߷s`IO
   newNode = (btree)malloc(sizeof(treeNode));
   //lƤG𪺸MBk
   newNode->item = value;
   newNode->left = NULL;
   newNode->right = NULL;

   if (root == NULL)
   {
      root = newNode;
      root->left = NULL;
      root->right = NULL;
   }
   else
   {
      ptr = root; //ptrШXC
      while (ptr != NULL )
      {
         papa = ptr;           //o`Ipapa
         //ثe`I > ǤJȴN]lA_hNOkl
         if (ptr->item > value )
            ptr = ptr->left;
         else
            ptr = ptr->right;
      }
      if (papa->item > value)   //_Bl쵲
         papa->left = newNode;
      else
         papa->right = newNode;
   }
   return root;
}

/*  dXGjM𪺸`I  */
btree btreeFind(btree ptr, int value, int *pos)
{
   btree papa = ptr;
   *pos = 0;                    //]_쪺m
   while(ptr != NULL )         //XGjM
   {
      if(ptr->item == value ) //FN^Ǧ`I
         return papa;          //^ǥ`I papa
      else
      {
         papa = ptr;
         if(ptr->item > value) //`IƻPǤJȤ
         {
            ptr = ptr->left;    //l
            *pos = -1;
         }
            
         else
         {
            ptr = ptr->right;   //kl
            *pos = 1;
         }
      }
   }
   return NULL;                 //S
}

/*  RG𪺸`I  */
btree btreeDelete(btree root, int value)
{
   btree ptr, papa, child;
   int pos;                       //Rm 

   //oǤJȪ`I papa
   papa = btreeFind(root, value, &pos);
   if(papa == NULL )        //`IpapaNULLܨS
      return root;

   switch(pos)              //̶ǤJm
   {
      case -1:
         ptr = papa->left;  //l`I
         break;
      case  1:
         ptr = papa->right; //kl`I
         break;
      case  0:
         ptr = papa;        //ڸ`I
         break;
   }

   //p@: Sl
   if(ptr->left == NULL )
   {
      //YDڸ`I_HDڸ`I, `Ikl`IVثe`Ikl`I
      if(papa != ptr )
         papa->right = ptr->right;
      else //hڸ`IVkl`I
         root = root->right;
      printf("\n2.ptr = %d", ptr->item);
      free(ptr);
      return root; 
   }

   //pG: Skl
   if(ptr->right == NULL )
   {
      //YDڸ`I_HDڸ`I, `Il`IVثe`I`I
      if(papa != ptr )
         papa->left = ptr->left;
      else   //hڸ`IVl`I
         root = root->left;
      free(ptr);
      return root; 
   }
   
   //pT: Bkl
   papa = ptr;                   //`IVثe`I
   child = ptr->left;            //]wl`I child
   while(child->right != NULL )  //̥k`I
   {
      papa = child;              //Od`I
      child = child->right;      //kl
   }

   ptr->item = child->item;      //]w`I
   if(papa->left == child)       //إߤBl쵲
      papa->left = child->left;  //l`I 
   else
      papa->right = child->right;//̥k`I
   printf("\n5.ptr = %d", ptr->item);
   free(child);
   return root;
}

/* HǨXXG */
void inorder(btree root)
{
   if(root != NULL)
   {
      inorder(root->left);           //1.Xl
      printf("[%d]->", root->item);  //2.AX
      inorder(root->right);          //3.̫ᨫXkl
   }
}

void main()
{
   btree root = NULL, ptr = NULL;
   int value;
   int ary[] = {60, 25, 93, 34, 18, 79};
   for(int j = 0; j < 6; j++)
      root = append(root, ary[j]);

   printf("ǨX BST:\n");
   inorder(root);

   printf("\nпJdX`I -> ");
   scanf("%d", &value);

   root = btreeDelete(root, value);   //Is禡R`I
   printf("\nBST Ҿl`I\n");
   inorder(root);
}
