#include<stdio.h>
#include<stdlib.h>

typedef struct node           //ϧucŧi
{
   int start;                 //}lI
   int halt;                  //פI
   int cost;                  //v
   struct node *next;         //U@u
}edgeNode;
typedef edgeNode *elink;        //uc

elink list = NULL;             //uC}l 
int edge[6];                   //I}C

/*  إuC  */
elink createEdge(elink list, int *Edges, int value)
{
   elink newNode;              //su`I 
   elink last;                 //̫u`I
   int j;

   for(j = 0; j < value; j++)
   {
      //s`ItmO
      newNode = (elink) malloc (sizeof(edgeNode));
      newNode->start = Edges[3 * j];     //u_I
      newNode->halt  = Edges[3 * j + 1]; //uI
      newNode->cost  = Edges[3 * j + 2]; //إߦe
      newNode->next = NULL;

      if(list == NULL)         //Ĥ@Ӹ`I
      {
         list = newNode;       //إߦC}l 
         last = list;          //Od̫`I 
      }
      else
      {
         last->next = newNode;  //쵲̫ܳ`I
         last = newNode;        //Od̫`I
      }
   }
   return list;                 //Ǧ^C}l
}

/*  XP@X  */
int makeGroup(int start, int halt)
{
   int root;
   root = halt;                  //qII
   while(edge[root] > 0)
      root = edge[root];
   edge[root] = start;          //XӳI
}

/*  O_sۦPX  */
int workGroup(int start, int halt)
{
   int go_root;
   int root_stop;

   go_root = start;              //q}lI
   while(edge[go_root] > 0 )
      go_root = edge[go_root];
   root_stop = halt;            //qII
   while(edge[root_stop] > 0)
      root_stop = edge[root_stop];
   if (go_root == root_stop)    //O_ۦPX
      return 1;
   else
      return 0;
}

/*  ϧΪ̤pXi  */
void kruskal()
{
   elink ptr;
   ptr = list;                    //VC}l
   while(ptr != NULL)
   {
      //P@X_?
      if(! workGroup(ptr->start, ptr->halt))
      {
         //LX̤p
         printf(" I ( %d, %d )  %2d\n", ptr->start,
                  ptr->halt, ptr->cost);
         makeGroup(ptr->start, ptr->halt); //XP@X
      }
      ptr = ptr->next;                     //U@u
   }
}

void main()
{
   int Edges[10][3] = {{ 3, 4,  6 }, /* u}C       */
                       { 2, 3,  8 },
                       { 2, 4, 10 },
                       { 1, 5, 12 },
                       { 5, 6, 12 },
                       { 1, 6, 15 },
                       { 4, 5, 15 },
                       { 1, 2, 18 },
                       { 4, 6, 23 },
                       { 2, 6, 26} };
   int j;

   list = createEdge(list, Edges, 8);   //إuC
   for(j = 1; j <= 6; j++ )
      edge[j] = -1;
   printf("ϧΪ̤pXi:\n");
   kruskal();                 //إ̤߳pXi 
   printf("\nI}Ce:\n");
   for(j = 1; j <= 6; j++ )
      printf("[%d]", edge[j]);
   printf("\n");
}

